--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: MEDIAINFO
-- @author		Valentin Schmidt
-- @version	 0.3
--****************************************************************************

property $

property _bin
property _sx

--property _cbHandler
--property _cbTarget
--
--property _tmpDir
--property _tmpFile

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

	-- libs
	--$.import("file")
	$.import("shell")
	$.import("xmlparser")

	me._bin = "mediainfo.exe"
	me._sx = $.clone($.shell)
	--me._tmpDir = getLongPathName(getEnvVar("TMP"))&"\"
	return me
end

----------------------------------------
--
----------------------------------------
on getInfo (me, mediaFile, fullFlag)
	xml = $.mediainfo.getInfoXml(mediaFile, fullFlag) --, "Video;%Duration%")
	--put xml
	$.xmlparser.parseString(xml)
	pl = $.xmlparser.makePropList()
	return $.xmlparser.makeSimplePropList(pl, TRUE)
end

----------------------------------------
--
----------------------------------------
on getTrackTypes (me, mediaFile)
	res = me.getInfo(mediaFile)
	tracks = []
	repeat with track in res[#mediainfo][#file][#track]
		if listP(track) then
			if track[#__attributes][#type] = "Audio" and  track[#format] = "MIDI" then
				tracks.append("MIDI")
			else
				tracks.append(track[#__attributes][#type])
			end if
		end if
	end repeat
	return tracks
end

----------------------------------------
--
----------------------------------------
on getInfoXml (me, mediaFile, fullFlag)
	cmd = me._bin & " --Output=XML "
	if fullFlag then put "-f " after cmd
	put QUOTE&mediaFile&QUOTE after cmd
	cmd = me._convert(cmd)
	me._sx.shell_setcurrentdir(me.LIBDIR & $.OS)
	props = [:]
	props["use_cmd"] = FALSE
	props["timeout"] = 0
	props["buffer_size"] = 1 * 1024 * 1024 -- 1 MB
	res = me._sx.shell_cmd(cmd, props)
	return res
end

----------------------------------------
-- WIN ONLY
----------------------------------------
--on getInfoXmlAsync (me, mediaFile, cbHandler, cbTarget)
--	if voidP(cbTarget) then cbTarget=_movie
--	me._cbHandler = cbHandler
--	me._cbTarget = cbTarget
--
--	me._tmpFile = me._tmpDir & random(the maxinteger)
--	cmd = me._bin && "--Output=XML" && QUOTE&mediaFile&QUOTE &">"&QUOTE&me._tmpFile&QUOTE
--
--	me._sx.shell_setcurrentdir(me.libdir & $.OS)
--	props = [:]
--	props["timeout"] = 0
--	props["use_cmd"] = TRUE
--	props["cb_complete"] = #slotGetInfoXmlAsyncComplete
--	props["cb_target"] = me
--	cmd = me._convert(cmd)
--	me._sx.shell_cmd_thread(cmd, props)
--end

----------------------------------------
-- @callback
----------------------------------------
--on slotGetInfoXmlAsyncComplete (me, err)
--	res = $.file.getString(me._tmpFile)
--	$.file.delete(me._tmpFile)
--	call(me._cbHandler, me._cbTarget, res)
--end

----------------------------------------
--
----------------------------------------
on _convert (me, utf8)
	tmp = bytearray()
	tmp.writeString(utf8, "windows-1252")
	tmp[tmp.length+1] = 0
	tmp.position = 5
	return tmp.readByteArray(tmp.length-4)
end
